#!/usr/bin/env bash

while read; do
  (( i++ )) # this declares i as global for some reason
  left[$i]="${REPLY}"
done < <(cat input | cut -f 1 -d' ' | sort)
unset i # remove that pesky global $i

# same deal but for the right column, which has
# 3 spaces inbetween them, so we cut the 4th field
while read; do
  (( i++ ))
  right[$i]="${REPLY}"
done < <(cat input | cut -f 4 -d' ' | sort)
unset i

# we 1 the array so we can use the array length
# as the element number of the last element
for row in `seq 1 ${#left[@]}`; do
  # sed is a very silly way to get an absolute value
  echo ${left[$row]} - ${right[$row]} | bc | sed 's/-//g'
# tr turns newlines into spaces, then sed gets rid of the last one
done | tr '\n' '+' | sed 's/+$/\n/' | bc
