#!/usr/bin/env bash
declare -a report
while read; do
  # assign each number to an array element
  report=( `echo $REPLY` )
  diff_length=`bc<<<${#report[@]}-1`
  declare -a report_diff
  for i in `seq 1 $diff_length`; do
    report_diff+="`bc <<<${report[$i]}-${report[$i-1]}` "
  done

  # count numbers 1 through 3 in the list of differences
  numerality=`echo ${report_diff[@]} \
  | grep -o "[1-3]" | wc -l`

  # test if each number is 1 through 3
  if [ $numerality -eq $diff_length ]; then
    # count minus signs
    negativity=`echo ${report_diff[@]} \
    | grep -o "-" | wc -l`
    # we only want to see if all the signs are the same
    if [ $negativity -eq 0 ] || [ $negativity -eq $diff_length ]; then
      (( safe++ ))
    fi
  fi
  unset report_diff[@]
done < <(cat input)
echo $safe
