#!/usr/bin/env bash
# first argument is the file
# second argument is the array to assign to
# indexes lines/columns, respectively, from one,
#   starting from the top leftmost corner
# assumes the array is declared and associative
file_to_array(){
  while read; do
    local i
    (( i++ ))
    linelen=$(wc -L <<<"$REPLY")
    for j in $(seq 1 $linelen); do
      declare -g "$2[$j,$i]"="$(cut -b $j <<<"$REPLY")"
    done
  done < <(cat $1)
}

# take in a cordinate pair, and return it's neighbors
# starts from the top left
find_neighbors(){
  # we don't want these exporting
  local x
  local y
  local i
  local j
  x="$(cut -d ',' -f 1 <<<"$1")"
  y="$(cut -d ',' -f 2 <<<"$1")"
  for i in 1 0 -1; do
    for j in 1 0 -1; do
      echo -n "$((x-j))"
      echo -n ','
      echo "$((y-i))"
    done
  done
}

# first argument is an associative array
# second argument is a cordinate pair
# output is more or less just a 3x3 window
#   around the supplied cordinates
return_neighbors(){
  # bash namerefs give me the heebie jeebies
  declare -n arr="$1"
  while read; do
    local i
    (( i++ ))
    echo -n "${arr[$REPLY]}"
    # fill blank values with spaces
    if [[ ! "${arr[$REPLY]}" ]]; then
      echo -n ' '
    fi
    # (( expr )) exits non-zero if expr evaluates to zero
    if ! (( i % 3 )); then
      echo
    fi
  done < <(find_neighbors "$2")
}
